=head1 EasyTarget, quick Torrus config generator

EastTarget is a Torrus plugin designed for those users who need
to add some specific SNMP OIDs to Torrus collector, without
having to edit the complex XML files. EasyTarget is a quick way to
add a few new objects without too much efforts.

=head2 Installation

Follow the Torrus installation guide for the main software installation.

Install two Perl modules from CPAN:

  perl -MCPAN -e 'install Config::Tiny'
  perl -MCPAN -e 'install Config::Any'

Unpack the plugin distribution package in some directory:

  gzip -dc tp-easytarget-1.X.tar.gz | tar xvf -

Then run the Torrus plugin installation utility, pointing to the
unpacked plugin directory:

  torrus install_plugin tp-easytarget-1.X


=head2 Quick steps

EasyTarget accepts input files in Windows-style INI format. It is important
that the file extension is exactly ".ini". By default, the files are searched
in the current directpoy and then in F<@sitedir@/easytarget>.

The input file consists of sections, each representing a leaf or a subtree
of Torrus datasource tree. You define the default parameters at the top of
the file in global section, and then create a section for
each tree element that you want to define. Here is a minimalistic example:

 OUTXML = mydevices.xml

 [/EasyTarget/dev1]
 snmp-host = 10.0.0.1
 snmp-community = public
 snmp-object = 1.3.6.1.4.1.5655.4.2.2.1.1.1.1.1.1

 [/EasyTarget/dev2]
 snmp-host = 10.0.0.2
 snmp-community = public
 snmp-object = 1.3.6.1.4.1.5655.4.2.2.1.1.1.1.1.1

Here's a more complex example:

 OUTXML = mydevices.xml

 [/EasyTarget/Myrouter/]
 snmp-host = 10.0.0.1
 snmp-community = public

 [/EasyTarget/Myrouter/data1]
 snmp-object = 1.3.6.1.4.1.5655.4.2.2.1.1.1.1.1.1

 [/EasyTarget/Myrouter/data2]
 snmp-object = 1.3.6.1.4.1.5655.4.2.2.1.1.1.1.2.1

Next step is to feed the input file to EasyTarget:

 torrus et --in=mydevices.ini --verbose

Then you need to add the generated XML file to the tree by editing the
F<torrus-siteconfig.pl> file, and compile the resulting tree:

 torrus compile --tree=main --verbose

Now you can start the collector and Apache server if they aren't yet running.
If they were already running, you don't need to restart them.


=head2 Plugin documentation

The input file for the EasyTarget plugin is a two-level configuration file.
Currently Windows-style INI format is supported. Other formats implemented in
C<Config::Any> Perl module should also work, but they were not tested.

The input file consists of two parts: the global parameters and
per-section parameters. The section name defines the Torrus datasource
subtree or leaf: if the name ends with the slash (/), it denotes a subtree
and defines parameters for child leaves. Otherwise the section defines
a leaf. The section name should always start with slash.

There are two types of parameters: the ones consisting of capitals ([A-Z]) are
the parameters for the EasyTarget engine, and all others are the parameters
passed to the generated Torrus config file.

The prarameter C<easytarget-node> is set to the path as specified in the
section header in the input INI file.

There is no parameter inheritance. You can only define either a parameter
on the global level, or in each of the sections. That means, for example,
that if C<OUTXML> is missing at the global level, it should be present
in each section, regardless of the generated tree hierarchy.
If a parameter exists both at the global level and in a section,
the value in the section overrides the global one.

EasyTarget understands the following parameters:

=over 4

=item * C<OUTXML>

The name of the generated Torrus configuration XML. This parameter can be
set globally or per-section. For example, the value F<myisp1/targets1.xml>
would cause EasyTarget to generate the file
F<@sitexmldir@/myisp1/targets1.xml>.

=item * C<BUNDLE>

This parameter specifies the name of Torrus XML conifg file that would
include C<E<lt>incldeE<gt>> statements for every C<OUTXML> in every section.
This is useful if the EasyTarget file is long enough (e.g. automatically
generated by an external program) and contains multiple output file statements.

=item * C<INCLUDE>

Set this parameter to a comma-separated list of XML file names that
should be included in the generated file. Usually suh files contain some
template definitions.

=item * C<TEMPLATES>

Comma-separated list of templates that will be applied at the given
subtree or leaf in the output file.

=back

The following parameters are set implicitly to their default values:

=over 4

=item * C<data-dir>: '@defrrddir@'

This value is taken from the one given in C<defrrddir=DIR> parameter of
the Torrus configure script at its installation time. This is the directory
where the collector will generate the RRD files.

=item * C<data-file>: '%system-id%.easytarget.rrd'

This is the name of RRD file. System-id parameter is usually equal to
snmp-host.

=item * C<rrd-ds>: the same as the name of the leaf

This is the datasource name used in the RRD file for the corresponding
dataelement. It is usually equal to the last word in the leaf path,
and can be overridden by explicitly defining the parameter.

=item * C<snmp-version>: 2c

=item * C<snmp-port>: 161

=item * C<rrd-create-dstype>: 'COUNTER'

This is the type of the datasource to be collected. In case of non-counter
type of the OID, this parameter should be changed to C<GAUGE>.

=item * C<nodeid>: 'et//%easytarget-node%'

=back

By default, EasyTarget applies the template C<snmp-defaults> from
C<snmp-defs.xml> to each leaf.

The minimum set of parameters that should be defined in EasyTarget
input files are: C<OUTXML>, C<snmp-host>, C<snmp-community>
and C<snmp-object>.

=head1 Author

Copyright (c) 2007 Stanislav Sinyagin E<lt>ssinyagin@yahoo.comE<gt>
